Index: trunk/kernel/ksh/clear.c
===================================================================
--- trunk/kernel/ksh/clear.c	(revision 1)
+++ trunk/kernel/ksh/clear.c	(revision 1)
@@ -0,0 +1,29 @@
+/*
+   This file is part of MutekP.
+  
+   MutekP is free software; you can redistribute it and/or modify it
+   under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2 of the License, or
+   (at your option) any later version.
+  
+   MutekP is distributed in the hope that it will be useful, but
+   WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   General Public License for more details.
+  
+   You should have received a copy of the GNU General Public License
+   along with MutekP; if not, write to the Free Software Foundation,
+   Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+  
+   UPMC / LIP6 / SOC (c) 2008
+   Copyright Ghassan Almaless <ghassan.almaless@gmail.com>
+*/
+
+#include <kminiShell.h>
+ 
+error_t clear_func(void* param)
+{
+  ksh_print("%c%c%c%c", 0x1b, '[', '2', 'J');
+  return 0;
+}
+
Index: trunk/kernel/ksh/cp.c
===================================================================
--- trunk/kernel/ksh/cp.c	(revision 1)
+++ trunk/kernel/ksh/cp.c	(revision 1)
@@ -0,0 +1,82 @@
+/*
+	 This file is part of MutekP.
+	
+	 MutekP is free software; you can redistribute it and/or modify it
+	 under the terms of the GNU General Public License as published by
+	 the Free Software Foundation; either version 2 of the License, or
+	 (at your option) any later version.
+	
+	 MutekP is distributed in the hope that it will be useful, but
+	 WITHOUT ANY WARRANTY; without even the implied warranty of
+	 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+	 General Public License for more details.
+	
+	 You should have received a copy of the GNU General Public License
+	 along with MutekP; if not, write to the Free Software Foundation,
+	 Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+	
+	 UPMC / LIP6 / SOC (c) 2008
+	 Copyright Ghassan Almaless <ghassan.almaless@gmail.com>
+*/
+
+#include <string.h>
+#include <stdint.h>
+#include <vfs.h>
+#include <kminiShell.h>
+
+error_t cp_func(void *param)
+{
+	char *src_name;
+	char *dest_name;
+	error_t err;
+	uint32_t argc;
+	uint32_t i;
+	ssize_t size;
+	struct ku_obj kuo;
+	struct vfs_file_s src_file;
+	struct vfs_file_s dest_file;
+	ms_args_t *args;
+	uint_t count;			/* FIXME to be correctly used */
+
+	args  = (ms_args_t *) param;
+	argc = args->argc;
+	dest_name = args->argv[argc - 1];
+	err = 0;
+	
+	KK_BUFF(kuo, dest_name);
+	if((err=vfs_open(ms_n_cwd, &kuo, VFS_O_WRONLY | VFS_O_CREATE,0, &dest_file)))
+		return err;
+	
+	argc --;
+
+	for(i=1; i< argc; i++)
+	{
+		src_name = args->argv[i];
+		
+		KK_BUFF(kuo, src_name);
+		if((err=vfs_open(ms_n_cwd, &kuo,VFS_O_RDONLY,0, &src_file))){
+			vfs_close(&dest_file, &count);
+			ksh_print("error while opinig %s\n",src_name);
+			return err;
+		}
+		size = 0;
+		KK_SZ_BUFF(kuo, buffer, BUFFER_SIZE);
+		while((size = vfs_read(&src_file, &kuo)) > 0)
+		{
+			//KK_SZ_BUFF(kuo, buffer, BUFFER_SIZE);
+			if((size=vfs_write(&dest_file, &kuo)) < 0)
+			goto CP_FUNC_ERROR;
+		}
+		
+		if(size < 0) goto CP_FUNC_ERROR;
+		vfs_close(&src_file, &count);
+	}
+	vfs_close(&dest_file,&count);
+	return 0;
+
+ CP_FUNC_ERROR:
+	vfs_close(&src_file,&count);
+	vfs_close(&dest_file,&count);
+	
+	return size;
+}
Index: trunk/kernel/ksh/eomtkp.c
===================================================================
--- trunk/kernel/ksh/eomtkp.c	(revision 1)
+++ trunk/kernel/ksh/eomtkp.c	(revision 1)
@@ -0,0 +1,109 @@
+/*
+   This file is part of MutekP.
+  
+   MutekP is free software; you can redistribute it and/or modify it
+   under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2 of the License, or
+   (at your option) any later version.
+  
+   MutekP is distributed in the hope that it will be useful, but
+   WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   General Public License for more details.
+  
+   You should have received a copy of the GNU General Public License
+   along with MutekP; if not, write to the Free Software Foundation,
+   Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+  
+   UPMC / LIP6 / SOC (c) 2008
+   Copyright Ghassan Almaless <ghassan.almaless@gmail.com>
+*/
+
+#include <cpu.h>
+#include <string.h>
+#include <stdint.h>
+#include <kminiShell.h>
+#include <vfs.h>
+#include <sgiImg.h>
+#include <sys-vfs.h>
+
+#ifdef BUFFER_SIZE
+#undef BUFFER_SIZE //512 //2048
+#define BUFFER_SIZE 512
+#endif
+
+error_t eomtkp_func(void *param)
+{
+  char *src_name;
+  error_t err;
+  uint16_t x_size;
+  uint16_t y_size;
+  ssize_t size;
+  int src_fd;
+  int dst_fd;
+  int tmp_fd;
+  clock_t tm_start;		/* start of command */
+  clock_t tm_header;		/* image's header paressing */
+  clock_t tm_end;		/* end of command */
+  clock_t tm_tmp;
+  ms_args_t *args;
+  struct sgi_info_s *sgi_info;
+
+  sys_clock(&tm_start);
+
+  args  = (ms_args_t *) param;
+  src_name = args->argv[1];
+  err = 0;
+  memset(buffer,0,BUFFER_SIZE);
+
+  if((dst_fd = sys_open("/DEV/SCREEN",VFS_O_WRONLY,0)) == -1)
+    return -1;
+      
+  if((src_fd = sys_open(src_name,VFS_O_RDONLY,0)) == -1){
+    sys_close(dst_fd);
+    ksh_print("error while opinig %s\n",src_name);
+    return -2;
+  }
+  
+  if((size = sys_read(src_fd, buffer,sizeof(*sgi_info))) < 0)
+  {
+    sys_close(dst_fd);
+    sys_close(src_fd);
+    return -3;
+  }
+
+  sgi_info = (struct sgi_info_s*) buffer;
+  x_size = SGI_TO_LE2(sgi_info->x_size);
+  y_size = SGI_TO_LE2(sgi_info->y_size);
+
+  if((tmp_fd = sys_open("/DEV/SCREEN",VFS_O_WRONLY,0)) == -1)
+    return -1;
+  
+  ksh_print("Image XSIZE %d, YSIZE %d\n", x_size, y_size);
+  ksh_print("Image Name: %s\n", sgi_info->img_name);
+  
+  if((size = sys_lseek(src_fd, sizeof(struct sgi_info_s), VFS_SEEK_SET)) == -1)
+    return -4;
+
+  sys_clock(&tm_tmp);
+  tm_header = tm_tmp - tm_start;
+
+  size = 0;
+  while((size = sys_read(src_fd,buffer,BUFFER_SIZE)) > 0)
+  {
+    if((size=sys_write(dst_fd,buffer,size)) < 0)
+      break;
+  }
+  
+  sys_close(src_fd);
+  sys_close(dst_fd);
+  
+  sys_clock(&tm_end);
+
+  ksh_print("  Command statistics:\n\tStart time: %u\n\tEnd time: %u\n\tElapsed time: %u\n\tHeader time: %u\n",
+	 tm_start,
+	 tm_end,
+	 tm_end - tm_start,
+	 tm_header);
+  return size;
+}
Index: trunk/kernel/ksh/error.c
===================================================================
--- trunk/kernel/ksh/error.c	(revision 1)
+++ trunk/kernel/ksh/error.c	(revision 1)
@@ -0,0 +1,65 @@
+/*
+   This file is part of MutekP.
+  
+   MutekP is free software; you can redistribute it and/or modify it
+   under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2 of the License, or
+   (at your option) any later version.
+  
+   MutekP is distributed in the hope that it will be useful, but
+   WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   General Public License for more details.
+  
+   You should have received a copy of the GNU General Public License
+   along with MutekP; if not, write to the Free Software Foundation,
+   Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+  
+   UPMC / LIP6 / SOC (c) 2008
+   Copyright Ghassan Almaless <ghassan.almaless@gmail.com>
+*/
+
+#include <system.h>
+#include <stdint.h>
+#include <kminiShell.h>
+
+#if 0
+#define ERROR_NR 17
+
+static const   char *msg1 = "NOT FOUND" ;
+static const   char *msg2 = "NO MORE MEMROY RESSOURCES" ;
+static const   char *msg3 = "NO MORE SPACE" ;
+static const   char *msg4 = "I/O ERROR" ;
+static const   char *msg5 = "UNKNOWN ERROR" ;
+static const   char *msg6 = "INVAILD IN VALUE" ;
+static const   char *msg7 = "BAD BLOCK FOUND" ;
+static const   char *msg8 = "ALREADY EXIST !" ;
+static const   char *msg9 = "IT'S DIRECTORY !" ;
+static const   char *msg10 = "BAD FILE DESCRIPTOR" ;
+static const   char *msg11 = "IT'S A PIPE OR FIFO" ;
+static const   char *msg12 = "SIZE OVERFLOW" ;
+static const   char *msg13 = "IS NOT DIRECTORY" ;
+static const   char *msg14 = "END OF DIRECTORY" ;
+static const   char *msg15 = "NOT IMPLEMENTED BY THAT SUB-SYSTEM" ;
+static const   char *msg16 = "NO MORE READERS ON PIPE OR FIFO" ;
+static const   char *msg17 = "DIRECTORY IS NOT EMPTY" ;
+ 
+void print_error_msg(error_t err)
+{
+  const char *msg_tab[18] = {NULL,msg1,msg2,msg3,msg4,msg5,msg6,msg7,msg8,msg9, \
+			     msg10,msg11,msg12,msg13,msg14,msg15,msg16,msg17};
+
+  err = (err < 0) ? -err : err;
+  
+  if((err < 1) || (err > ERROR_NR))
+    ksh_print("Invaild error code !!! %d\n", err);
+  else
+    ksh_print("Error: %s\n",msg_tab[err]);
+}
+
+#else
+void print_error_msg(error_t err)
+{
+  ksh_print("Command has failed\n");
+}
+#endif
Index: trunk/kernel/ksh/exec_func.c
===================================================================
--- trunk/kernel/ksh/exec_func.c	(revision 1)
+++ trunk/kernel/ksh/exec_func.c	(revision 1)
@@ -0,0 +1,67 @@
+/*
+   This file is part of MutekP.
+  
+   MutekP is free software; you can redistribute it and/or modify it
+   under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2 of the License, or
+   (at your option) any later version.
+  
+   MutekP is distributed in the hope that it will be useful, but
+   WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   General Public License for more details.
+  
+   You should have received a copy of the GNU General Public License
+   along with MutekP; if not, write to the Free Software Foundation,
+   Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+  
+   UPMC / LIP6 / SOC (c) 2008
+   Copyright Ghassan Almaless <ghassan.almaless@gmail.com>
+*/
+
+#include <stdint.h>
+#include <thread.h>
+#include <task.h>
+#include <kminiShell.h>
+
+char *envrion[] = { "ALMOS_VERSION=v1", NULL};
+ 
+error_t exec_func(void *param)
+{
+  char *path_name;
+  //error_t err;
+  uint32_t argc,i;
+  ms_args_t *args;
+  char *argv[MS_MAX_ARG_LEN + 1];
+
+  args = (ms_args_t *) param;
+  argc = args->argc;
+
+  if(argc < 2)
+  {
+    ksh_print("exec: missing operand\n");
+    return EINVAL;
+  }
+
+  path_name = args->argv[1];
+
+  for(i=1; i < argc; i++)
+    argv[i-1] = args->argv[i];
+
+  argv[argc - 1] = NULL;
+  
+#if 0
+  for(i=0; i < argc; i++)
+    ksh_print("%s: argv[%d]=%x, argv[%d]=%s\n", __FUNCTION__,i, argv[i], i, (argv[i] == NULL) ? "NULL" : argv[i]);
+#endif
+
+#if 0
+  if((err = do_exec(current_task, path_name, argv, &envrion[0])))
+  {
+    ksh_print("exec: error %d, faild to execute command %s\n", err, path_name);
+    return err;
+  }
+#endif
+  return 0;
+}
+
Index: trunk/kernel/ksh/instrument.c
===================================================================
--- trunk/kernel/ksh/instrument.c	(revision 1)
+++ trunk/kernel/ksh/instrument.c	(revision 1)
@@ -0,0 +1,37 @@
+/*
+   This file is part of MutekP.
+  
+   MutekP is free software; you can redistribute it and/or modify it
+   under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2 of the License, or
+   (at your option) any later version.
+  
+   MutekP is distributed in the hope that it will be useful, but
+   WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   General Public License for more details.
+  
+   You should have received a copy of the GNU General Public License
+   along with MutekP; if not, write to the Free Software Foundation,
+   Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+  
+   UPMC / LIP6 / SOC (c) 2008
+   Copyright Ghassan Almaless <ghassan.almaless@gmail.com>
+*/
+
+#include <fat32.h>
+#include <fat32-private.h>
+#include <kminiShell.h>
+
+
+error_t show_instrumentation(void *param)
+{
+ #if CONFIG_VFAT_INSTRUMENT && CONFIG_BC_INSTRUMENT
+  ksh_print("Total reads: %d\nTotal writes: %d\nDevBlok read %d\n\nHit: %d\nMiss %d\nDelayed Write %d\n",
+	   rd_count, wr_count, blk_rd_count,hit_count, miss_count, dw_count);
+#else
+  ksh_print("Total reads: N/A\nTotal writes: N/A\nDevBlok read N/A\n\nHit: N/A\nMiss N/A\nDelayed Write N/A\n");
+#endif
+
+  return 0;
+}
Index: trunk/kernel/ksh/kill.c
===================================================================
--- trunk/kernel/ksh/kill.c	(revision 1)
+++ trunk/kernel/ksh/kill.c	(revision 1)
@@ -0,0 +1,62 @@
+/*
+   This file is part of MutekP.
+  
+   MutekP is free software; you can redistribute it and/or modify it
+   under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2 of the License, or
+   (at your option) any later version.
+  
+   MutekP is distributed in the hope that it will be useful, but
+   WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   General Public License for more details.
+  
+   You should have received a copy of the GNU General Public License
+   along with MutekP; if not, write to the Free Software Foundation,
+   Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+  
+   UPMC / LIP6 / SOC (c) 2008
+   Copyright Ghassan Almaless <ghassan.almaless@gmail.com>
+*/
+
+#include <kminiShell.h>
+#include <list.h>
+#include <thread.h>
+#include <task.h>
+#include <signal.h>
+
+error_t kill_func(void *param)
+{
+  ms_args_t *args;
+  uint32_t argc;
+  uint_t sig;
+  pid_t pid;
+  cid_t location;
+  error_t err;
+
+  args  = (ms_args_t *) param;
+  argc = args->argc;
+  err = 0;
+
+  if(argc != 3)
+  {
+    ksh_print("Missing signal number or process pid\n");
+    return EINVAL;
+  }
+
+  sig = atoi(args->argv[1]);
+  pid = atoi(args->argv[2]);
+
+  if((sig == 0)  || (sig >= SIG_NR))
+  {
+    ksh_print("Unknown signal number: %d\n", sig);
+    return EINVAL;
+  }
+
+  location = task_whereis(pid);
+
+  if((err = signal_rise(pid, location, sig)))
+    ksh_print("Failed to rise signal %d on task %d\n", sig, pid);
+
+  return err;
+}
Index: trunk/kernel/ksh/kminiShell.h
===================================================================
--- trunk/kernel/ksh/kminiShell.h	(revision 1)
+++ trunk/kernel/ksh/kminiShell.h	(revision 1)
@@ -0,0 +1,75 @@
+/*
+    This file is part of MutekP.
+
+    MutekP is free software; you can redistribute it and/or modify it
+    under the terms of the GNU General Public License as published by
+    the Free Software Foundation; either version 2 of the License, or
+    (at your option) any later version.
+
+    MutekP is distributed in the hope that it will be useful, but
+    WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+    General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with MutekP; if not, write to the Free Software Foundation,
+    Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+
+    UPMC / LIP6 / SOC (c) 2008
+    Copyright Ghassan Almaless <ghassan.almaless@gmail.com>
+*/
+
+#ifndef __MINI_SHELL_H__
+#define __MINI_SHELL_H__
+
+#include <vfs.h>
+#include <kdmsg.h>
+
+#define MS_MAX_ARG_LEN    20
+#define MS_MAX_LINE_LEN   64
+#define BUFFER_SIZE       4096
+#define MSG_STR_LEN       512
+
+extern uint8_t buffer[];
+extern kdmsg_channel_t ksh_tty;
+
+typedef struct ms_argument_s
+{
+  uint_t argc;
+  char argv[MS_MAX_ARG_LEN][MS_MAX_LINE_LEN];
+}ms_args_t;
+
+extern struct vfs_file_s *root ;
+extern struct vfs_file_s *ms_n_cwd ;
+extern char ms_pwd[128] ;
+
+void print_error_msg(error_t err)  ;
+void ksh_print(const char *fmt, ...);
+void ksh_write(void *buff, size_t size);
+char getChar() ;
+void putChar(char ch) ;
+void cmdLineAnalyser(ms_args_t *args);
+
+typedef error_t (ksh_cmd_t)(void*);
+
+/* Commands */
+error_t clear_func(void* param);
+error_t rm_func(void *parm) ;
+error_t cd_func(void *parm) ;
+error_t ls_func(void *param) ;
+error_t mkdir_func(void *param) ;
+error_t cp_func(void *arg) ;
+error_t mkfifo_func(void *param) ;
+error_t cat_func(void *param) ;
+error_t cat2_func(void *param) ;
+error_t eomtkp_func(void *param) ;
+error_t ps_func(void *param);
+error_t show_instrumentation(void* param) ;
+error_t exec_func(void *param);
+error_t pwd_func(void *param);
+error_t ksh_set_tty_func(void *param);
+error_t ppm_func(void *param);
+error_t ksh_cpu_state_func(void *param);
+error_t kill_func(void *param);
+
+#endif
Index: trunk/kernel/ksh/ksh_cpu_state.c
===================================================================
--- trunk/kernel/ksh/ksh_cpu_state.c	(revision 1)
+++ trunk/kernel/ksh/ksh_cpu_state.c	(revision 1)
@@ -0,0 +1,69 @@
+/*
+   This file is part of MutekP.
+  
+   MutekP is free software; you can redistribute it and/or modify it
+   under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2 of the License, or
+   (at your option) any later version.
+  
+   MutekP is distributed in the hope that it will be useful, but
+   WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   General Public License for more details.
+  
+   You should have received a copy of the GNU General Public License
+   along with MutekP; if not, write to the Free Software Foundation,
+   Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+  
+   UPMC / LIP6 / SOC (c) 2008
+   Copyright Ghassan Almaless <ghassan.almaless@gmail.com>
+*/
+
+#include <config.h>
+#include <kminiShell.h>
+#include <list.h>
+#include <thread.h>
+#include <task.h>
+#include <cluster.h>
+#include <cpu.h>
+#include <spinlock.h>
+#include <system.h>
+#include <wait_queue.h>
+
+//FIXME do it for all cluster
+error_t ksh_cpu_state_func(void *param)
+{
+	register uint_t cld, cpu;
+	uint_t cpu_nr;
+	ms_args_t args;
+
+#if 0
+	uint_t clstr_nr;
+	clstr_nr = arch_onln_cluster_nr();
+ 
+	for(cld=0; cld < clstr_nr; cld ++)
+	{
+		ksh_print("/SYS/CLUSTER%d\n", cld);
+		cpu_nr = clusters_tbl[cld].cluster->cpu_nr;
+
+		for(cpu=0; cpu < cpu_nr; cpu++)
+		{
+			args.argc = 2;
+			sprintk(args.argv[1], "/SYS/CLUSTER%d/CPU%d", cld,cpu);
+			cat_func(&args);
+		}
+	}
+#endif
+	cld = current_cid;
+	cpu_nr = current_cluster->cpu_nr;
+	ksh_print("/SYS/CLUSTER%d\n", current_cid);
+
+	for(cpu=0; cpu < cpu_nr; cpu++)
+	{
+		args.argc = 2;
+		sprintk(args.argv[1], "/SYS/CLUSTER%d/CPU%d", cld, cpu);
+		cat_func(&args);
+	}
+
+	return 0;
+}
Index: trunk/kernel/ksh/ksh_set_tty.c
===================================================================
--- trunk/kernel/ksh/ksh_set_tty.c	(revision 1)
+++ trunk/kernel/ksh/ksh_set_tty.c	(revision 1)
@@ -0,0 +1,50 @@
+/*
+   This file is part of MutekP.
+  
+   MutekP is free software; you can redistribute it and/or modify it
+   under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2 of the License, or
+   (at your option) any later version.
+  
+   MutekP is distributed in the hope that it will be useful, but
+   WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   General Public License for more details.
+  
+   You should have received a copy of the GNU General Public License
+   along with MutekP; if not, write to the Free Software Foundation,
+   Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+  
+   UPMC / LIP6 / SOC (c) 2008
+   Copyright Ghassan Almaless <ghassan.almaless@gmail.com>
+*/
+
+#include <kminiShell.h>
+#include <system.h>
+#include <device.h>
+
+error_t ksh_set_tty_func(void *param)
+{
+  ms_args_t *args ;
+  sint_t id = -1;
+
+  args  = (ms_args_t *) param;
+
+  if(args->argc == 2)
+    id = atoi(args->argv[1]);
+  
+  if(id == -1)
+  {
+    ksh_print("%s: Unknown TTY id\n", __FUNCTION__);
+    return EINVAL;
+  }
+
+  if((id >= TTY_DEV_NR) || (ttys_tbl[id] == NULL))
+  {
+    ksh_print("%s: Invalid TTY id: %d\n", __FUNCTION__, id);
+    return EINVAL;
+  }
+
+  ksh_tty.id = id;
+  return 0;
+}
Index: trunk/kernel/ksh/ls.c
===================================================================
--- trunk/kernel/ksh/ls.c	(revision 1)
+++ trunk/kernel/ksh/ls.c	(revision 1)
@@ -0,0 +1,143 @@
+/*
+	 This file is part of MutekP.
+	
+	 MutekP is free software; you can redistribute it and/or modify it
+	 under the terms of the GNU General Public License as published by
+	 the Free Software Foundation; either version 2 of the License, or
+	 (at your option) any later version.
+	
+	 MutekP is distributed in the hope that it will be useful, but
+	 WITHOUT ANY WARRANTY; without even the implied warranty of
+	 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+	 General Public License for more details.
+	
+	 You should have received a copy of the GNU General Public License
+	 along with MutekP; if not, write to the Free Software Foundation,
+	 Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+	
+	 UPMC / LIP6 / SOC (c) 2008
+	 Copyright Ghassan Almaless <ghassan.almaless@gmail.com>
+*/
+
+#include <stdint.h>
+#include <vfs.h>
+#include <kminiShell.h>
+#include <errno.h>
+
+static struct vfs_dirent_s dirent ;
+
+ void show3(void);
+ void show1(void);
+ void show2(void);
+
+error_t ls_func(void *param)
+{
+	char *path_name;
+	error_t err;
+	uint32_t argc;
+	uint32_t i;
+	uint_t count;
+	struct vfs_file_s dir;
+	struct ku_obj kuo;
+	ms_args_t *args;
+	//  char ch;
+
+	args  = (ms_args_t *) param;
+	err  = 0;
+
+	if(args->argc == 1)
+	{
+		argc = 2;
+		args->argv[1][0] = '.';
+		args->argv[1][1] = 0;
+	}
+	else
+		argc = args->argc;
+
+	for(i=1; i < argc; i++)
+	{
+		if(argc == 1)
+			path_name = ".";
+		else
+			path_name = args->argv[i];
+	 
+#if 0 
+		ksh_print("calling vfs for path_name |%s|\n", path_name);
+#endif
+
+		KK_BUFF(kuo, path_name);
+		if((err=vfs_opendir(ms_n_cwd, &kuo,0,&dir)))
+			return err;
+		
+		ksh_print("Name\t\tType\t\tSize\n", path_name);
+		ksh_print("----\t\t----\t\t----\n", path_name);
+		count = 0;
+		
+		KK_OBJ(kuo, &dirent);
+		while(!(err=vfs_readdir(&dir,&kuo)))
+		{
+			count++;
+			show3();
+
+#if 0      
+			ch=getChar();
+			
+			if(ch == '\n')
+			{
+	ch=getChar();
+	continue;
+			} 
+			if(ch == 'q') goto LS_END;
+#endif
+		}
+		ksh_print("\n%d found\n",count);
+		//  LS_END:
+		vfs_closedir(&dir, &count);
+		if(err != EEODIR) return err;
+	}
+	return 0;
+}
+
+ void show3(void)
+{
+	ksh_print("%s\t\t", dirent.d_name);
+
+	switch(dirent.d_attr)
+	{
+	case VFS_DIR:
+		ksh_print("<DIR>");
+		break;
+	case VFS_FIFO:
+		ksh_print("<FIFO>");
+		break;
+	case VFS_DEV_BLK:
+		ksh_print("<DEV-BLK>");
+		break;
+	case VFS_DEV_CHR:
+		ksh_print("<DEV-CHR>");
+		break;
+	default:
+		ksh_print("<RegFile>");
+	}
+	ksh_print("\n");
+}
+
+ void show1(void)
+{
+	ksh_print("=============================\n");
+	ksh_print("Entry name %s\t", dirent.d_name);
+	ksh_print("\tType: %s\n", (VFS_IS(dirent.d_attr, VFS_DIR)) ? "<DIR>" : 
+	   (VFS_IS(dirent.d_attr, VFS_FIFO)) ? "FIFO file" : "Reg file");
+	ksh_print("=============================\n");
+}
+
+ void show2(void)
+{
+	ksh_print("=============================\n");
+	ksh_print("Entry name %s\t\t\t\t",
+	    dirent.d_name);
+
+	ksh_print("\t\tType: %s\n", (VFS_IS(dirent.d_attr, VFS_DIR)) ? "<DIR>" : 
+	   (VFS_IS(dirent.d_attr, VFS_FIFO)) ? "FIFO file" : "Reg file");
+	ksh_print("=============================\n");
+}
Index: trunk/kernel/ksh/miniShell.c
===================================================================
--- trunk/kernel/ksh/miniShell.c	(revision 1)
+++ trunk/kernel/ksh/miniShell.c	(revision 1)
@@ -0,0 +1,215 @@
+/*
+   This file is part of MutekP.
+  
+   MutekP is free software; you can redistribute it and/or modify it
+   under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2 of the License, or
+   (at your option) any later version.
+  
+   MutekP is distributed in the hope that it will be useful, but
+   WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   General Public License for more details.
+  
+   You should have received a copy of the GNU General Public License
+   along with MutekP; if not, write to the Free Software Foundation,
+   Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+  
+   UPMC / LIP6 / SOC (c) 2008
+   Copyright Ghassan Almaless <ghassan.almaless@gmail.com>
+*/
+
+#include <system.h>
+#include <stdint.h>
+#include <string.h>
+#include <vfs.h>
+#include <thread.h>
+#include <kminiShell.h>
+#include <task.h>
+
+#define NR_THREADS  1
+
+uint8_t buffer[BUFFER_SIZE];
+
+struct vfs_file_s *root ;
+struct vfs_file_s *ms_n_cwd ;
+
+ms_args_t args;
+
+void print_args(ms_args_t *args)
+{
+  int i;
+
+  for(i=0; i < MS_MAX_ARG_LEN; i++)
+  {
+    ksh_print("idx %d:",i);
+    if(args->argv[i] != NULL)
+      ksh_print("|%s|\n", args->argv[i]);
+    else
+      ksh_print("NULL\n");
+  }
+
+  ksh_print("argc %d\n", args->argc);
+}
+
+
+typedef struct ksh_builtin_s
+{
+  char *name;
+  char *info;
+  ksh_cmd_t *cmd;
+}ksh_builtin_t;
+
+static error_t help_func(void *param);
+
+
+static ksh_builtin_t builtin_cmds[] = 
+  {
+    {"setty", "Set I/O Terminal Number", ksh_set_tty_func},
+    {"cd", "Change Directory", cd_func},
+    {"ls", "List Files In Directory", ls_func},
+    {"cp", "Copy File", cp_func},
+    {"cat", "Show File Contentes", cat_func},
+    {"ps", "Show Process (Tasks) State", ps_func},
+    {"exec", "Execute New Process", exec_func},
+    {"ppm", "Print Phyiscal Pages Manager", ppm_func},
+    {"cs", "CPUs Stats", ksh_cpu_state_func},
+    {"stat", "Show File System Instrumentation", show_instrumentation},
+    {"pwd", "Print Work Directory", pwd_func},
+    {"rm", "Remove File", rm_func},
+    {"kill", "Send the specified signal to the specified process", kill_func},
+    {"eomtkp", "Display SGI Image On Frame-Buffer", eomtkp_func},
+    {"clear", "Clear Some Lines", clear_func},
+    {"mkdir", "Make New Directory", mkdir_func},
+    {"mkfifo", "Make New Named FIFO File", mkfifo_func},
+    {"help", "Show Available commands", help_func},
+    {NULL,NULL,NULL}
+  };
+
+static error_t help_func(void *param)
+{
+  uint_t i;
+
+  ksh_print("Available Commands:\n");
+
+  for(i=0; builtin_cmds[i].name != NULL; i++)
+    ksh_print("%s: %s\n", builtin_cmds[i].name, builtin_cmds[i].info);
+
+  ksh_print("exit: Exit and synchronise panding disk wirtes if any\n");
+  return 0;
+}
+
+
+static error_t ksh_exec_cmd(char *cmd, ms_args_t *args)
+{
+  uint_t i;
+  error_t err;
+
+  for(i=0; builtin_cmds[i].name != NULL; i++)
+  {
+    if(!strcmp(cmd, builtin_cmds[i].name))
+    {
+      if((err=builtin_cmds[i].cmd(args)))
+	print_error_msg(err);
+      return 0;
+    }
+  }
+  return -1;
+}
+
+
+void* kMiniShelld(void *arg)
+{
+  ssize_t err;
+  struct task_s *task = current_task;
+  register char *cmd;
+
+  memset(&args,0,sizeof(args));
+  root = &task->vfs_root;
+  ms_n_cwd = &task->vfs_cwd;  
+
+#if 0
+  ksh_print("[%s]>",ms_n_cwd->n_name);
+  args.argc = 7;
+  strcpy(args.argv[0],"exec");
+  strcpy(args.argv[1],"/BIN/SHOWIMG.X");
+  strcpy(args.argv[2],"-p4");
+  strcpy(args.argv[3],"-i");
+  strcpy(args.argv[4],"/TMP/LENA.SGI");
+  strcpy(args.argv[5],"-o");
+  strcpy(args.argv[6],"/DEV/FB0");
+  
+  ksh_exec_cmd("exec", &args);
+#endif
+
+#if 0
+  ksh_print("[%s]>",ms_n_cwd->n_name);
+  args.argc = 7;
+  strcpy(args.argv[0],"exec");
+  strcpy(args.argv[1],"/BIN/HELLO.X");
+  strcpy(args.argv[2],"-p4");
+  strcpy(args.argv[3],"-i");
+  strcpy(args.argv[4],"/TMP/LENA.SGI");
+  strcpy(args.argv[5],"-o");
+  strcpy(args.argv[6],"/DEV/FB0");
+  
+  ksh_exec_cmd("exec", &args);
+
+  ksh_print("[%s]>",ms_n_cwd->n_name);
+  args.argc = 7;
+  strcpy(args.argv[0],"exec");
+  strcpy(args.argv[1],"/BIN/SHOWIMG.X");
+  strcpy(args.argv[2],"-p16");
+  strcpy(args.argv[3],"-i");
+  strcpy(args.argv[4],"/TMP/IMG.RGB");
+  strcpy(args.argv[5],"-o");
+  strcpy(args.argv[6],"/DEV/FB0");
+  
+  ksh_exec_cmd("exec", &args);
+
+#endif
+
+#if 0
+  task->vfs_cwd = ms_n_cwd;
+  ksh_print("[%s]>",ms_n_cwd->n_name);
+  args.argc = 2;
+  strcpy(args.argv[0],"cd");
+  strcpy(args.argv[1],"/tmp");
+  ksh_exec_cmd("cd", &args);
+
+  task->vfs_cwd = ms_n_cwd;
+  ksh_print("[%s]>",ms_n_cwd->n_name);
+  args.argc = 3;
+  strcpy(args.argv[0],"cp");
+  strcpy(args.argv[1],"r.txt");
+  strcpy(args.argv[2],"f.txt");
+  ksh_exec_cmd("cp", &args);
+#endif
+
+
+  while(1)
+  {
+    task->vfs_cwd = *ms_n_cwd;
+    //ksh_print("[%s]>",ms_n_cwd->n_name);FIXME
+    ksh_print("[%s]>", __FUNCTION__);
+    cmdLineAnalyser(&args);
+    cmd = args.argv[0];
+
+#if 0
+    print_args(&args);
+#endif
+
+    if((err=ksh_exec_cmd(cmd, &args)))
+    {
+      if(!strcmp(cmd, "exit"))
+	break;
+      else
+	ksh_print("Unknown command %s\n", cmd);
+    }
+  }
+
+  //bc_dump(&bc);
+  //bc_sync(&bc);
+  ksh_print("Finished\n");
+  return NULL;
+}
